C -*-fortran-*-
C++*********************************************************************
C
C PKSR3.F
C
C **********************************************************************
C=*                                                                    *
C=* This file is part of:   SPIDER - Modular Image Processing System.  *
C=* SPIDER System Authors:  Joachim Frank & ArDean Leith               *
C=* Copyright 1985-2010  Health Research Inc.,                         *
C=* Riverview Center, 150 Broadway, Suite 560, Menands, NY 12204.      *
C=* Email: spider@wadsworth.org                                        *
C=*                                                                    *
C=* SPIDER is free software; you can redistribute it and/or            *
C=* modify it under the terms of the GNU General Public License as     *
C=* published by the Free Software Foundation; either version 2 of the *
C=* License, or (at your option) any later version.                    *
C=*                                                                    *
C=* SPIDER is distributed in the hope that it will be useful,          *
C=* but WITHOUT ANY WARRANTY; without even the implied warranty of     *
C=* merchantability or fitness for a particular purpose.  See the GNU  *
C=* General Public License for more details.                           *
C=* You should have received a copy of the GNU General Public License  *
C=* along with this program. If not, see <http://www.gnu.org/licenses> *
C=*                                                                    *
C **********************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************


C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************
C Returns R, the subpixel amount of shift for the 3 values: QA,QMAX,QC

        SUBROUTINE  PKSR3_SUB(QMAX,QA,QC,SGN,R)
		 QF=0.0
		 QMID=0.0
		 QMIN=0.0
         IF (SGN.GT.0) THEN
            IF(QA.LT.QC) THEN
               QMIN = QA
               QMID = QC
               QF = 0.5
            ELSE
               QMIN = QC
               QMID = QA
               QF = -0.5
            ENDIF
         ENDIF
         IF (SGN.LT.0) THEN 
            IF(QA.GT.QC) THEN
               QMIN = QA
               QMID = QC
               QF = 0.5
            ELSE
               QMIN = QC
               QMID = QA
               QF = -0.5
            ENDIF
         ENDIF

         IF ((QMAX - QMIN).NE.0) THEN
            QM = QF / (QMAX - QMIN)
            R = QM * (QMID - QMIN)
         ENDIF

         RETURN

         END
